package org.seasar.javelin.jmx;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.text.SimpleDateFormat;
import java.util.Date;

public class S2JmxJavelinFileGenerator
{
    static String javelinFileDir_ = "";

    public S2JmxJavelinFileGenerator(String javelinFielDir)
    {
        this.javelinFileDir_ = javelinFielDir;
    }
    
    /**
     * JavelinOƂāAt@Cɏo͂B
     * 
     * @param node
     */
    public void generateJaveinFile(CallTree tree, CallTreeNode node)
    {
        String threadID = tree.getThreadID();
        Writer writer = null;
        try
        {
            String jvnFileName = createJvnFileDir();
            writer = new FileWriter(jvnFileName, true);

            // ċAIwriterɏ݂sB
            generateJavelinFileImpl(writer, threadID, node);
        }
        catch (IOException ioe)
        {
            // TODO ꂽ catch ubN
            ioe.printStackTrace();
        }
        finally
        {
            if (writer != null)
            {
                try
                {
                    writer.close();
                }
                catch (IOException ioe)
                {
                    // TODO ꂽ catch ubN
                    ioe.printStackTrace();
                }
            }
        }
    }

    private String createJvnFileDir( )
    {
        SimpleDateFormat jvnFileFormat = new SimpleDateFormat(
                                                              "yyyyMMddhhmmssSSS");

        return javelinFileDir_ + File.separator + "s2jmx_" + jvnFileFormat.format(new Date())
                + ".jvn";
    }

    /**
     * JavelinOƂāAt@Cɏo͂B
     * 
     * @param node
     */
    private void generateJavelinFileImpl(Writer writer, String threadID,
            CallTreeNode node)
    {
        String jvnCallMessage = JavelinLogMaker.createJavelinLog(
                                                                 JavelinLogMaker.ID_CALL,
                                                                 node.getStartTime(),
                                                                 threadID, node);

        // t@C1bZ[WށB
        try
        {
            writer.write(jvnCallMessage);
        }
        catch (IOException e)
        {
            // TODO ꂽ catch ubN
            e.printStackTrace();
        }

        for (CallTreeNode child : node.getChildren())
        {
            generateJavelinFileImpl(writer, threadID, child);
        }

        String jvnReturnMessage = JavelinLogMaker.createJavelinLog(
                                                                   JavelinLogMaker.ID_RETURN,
                                                                   node.getEndTime(),
                                                                   threadID,
                                                                   node);
        // t@C1bZ[WށB
        try
        {
            writer.write(jvnReturnMessage);
        }
        catch (IOException e)
        {
            // TODO ꂽ catch ubN
            e.printStackTrace();
        }
    }

}
