package org.seasar.javelin.jmx;

import java.lang.management.ManagementFactory;
import java.util.Set;

import javax.management.MBeanServer;
import javax.management.ObjectName;

import mx4j.tools.adaptor.http.HttpAdaptor;
import mx4j.tools.adaptor.http.XSLTProcessor;

import org.aopalliance.intercept.MethodInvocation;
import org.seasar.framework.aop.interceptors.AbstractInterceptor;
import org.seasar.javelin.jmx.bean.Container;
import org.seasar.javelin.jmx.bean.ContainerMBean;
import org.seasar.javelin.jmx.bean.Statistics;
import org.seasar.javelin.jmx.bean.StatisticsMBean;

/**
 * ComponentԂ̌Ăяo֌WMBeanƂČJ邽߂InterceptorB
 * ȉ̏AMBeanoRŎ擾邱Ƃ\B
 * <ol>
 * <li>\bȟĂяo</li>
 * <li>\bh̕Ϗԁi~bPʁj</li>
 * <li>\bh̍Œԁi~bPʁj</li>
 * <li>\bh̍ŒZԁi~bPʁj</li>
 * <li>\bȟĂяo</li>
 * <li>O̔</li>
 * <li>O̔</li>
 * </ol>
 * ܂Aȉ̏dicont@Cł̃p[^Ŏw\B
 * <ol>
 * <li>httpPort:HTTPŌJۂ̃|[gԍBgpɂMX4JKvB</li>
 * <li>intervalMax:\bh̏Ԃ񕪋L^邩B
 *     ftHgl1000B</li>
 * <li>throwableMax:O̔񕪋L^邩B
 *     ftHgl1000B</li>
 * <li>recordThreshold:ԋL^p臒lB
 *     ̎Ԃz\bhĂяô݋L^B
 *     ftHgl0B</li>
 * <li>domain:MBeano^ۂɎgphCB
 *     ۂ̃hĆA[domainp[^] + [Mbean̎]ƂȂB
 *     MBean̎ނ͈ȉ̂̂B
 *     <ol>
 *       <li>container:SR|[lgObjectNameǗB</li>
 *       <li>component:̃R|[lgɊւJMBeanB</li>
 *       <li>invocation:\bhĂяoɊւJMBeanB</li>
 *     </ol>
 *     </li>
 * </ol>
 * 
 * @version 0.1
 * @author Masanori Yamasaki(SMG)
 */
public class S2JmxJavelinInterceptor extends AbstractInterceptor
{
    private static final long  serialVersionUID = 6661781313519708185L;

    /** vbgtH[MBeanT[o */
    private static MBeanServer server_;

    /** tOBς݂̏ꍇtrueB */
    private static boolean     isInitialized_   = false;

    /**
     * JHTTP|[gԍBiMX4JKvBj
     */
    private int                httpPort_        = 0;

    private S2JmxJavelinConfig  config_ = new S2JmxJavelinConfig();

    /**
     * B
     * MBeanServerւContainerMBean̓o^sB
     * JpHTTP|[gw肳Ăꍇ́AHttpAdaptor̐Ɠo^sB
     */
    private void init( )
    {
        try
        {
            server_ = ManagementFactory.getPlatformMBeanServer();

            if (httpPort_ != 0)
            {
                XSLTProcessor processor = new XSLTProcessor();
                ObjectName processorName = new ObjectName(
                                                          "Server:name=XSLTProcessor");
                if (server_.isRegistered(processorName))
                {
                    Set beanSet = server_.queryMBeans(processorName, null);
                    if (beanSet.size() > 0)
                    {
                        XSLTProcessor[] processors = (XSLTProcessor[])beanSet.toArray(new XSLTProcessor[beanSet.size()]);
                        processor = (XSLTProcessor)(processors[0]);
                    }
                }
                else
                {
                    server_.registerMBean(processor, processorName);
                }

                HttpAdaptor adaptor;
                ObjectName adaptorName = new ObjectName(
                                                        "Adaptor:name=adaptor,port="
                                                                + httpPort_);
                if (server_.isRegistered(adaptorName))
                {
                    Set beanSet = server_.queryMBeans(adaptorName, null);
                    if (beanSet.size() > 0)
                    {
                        HttpAdaptor[] adaptors = (HttpAdaptor[])beanSet.toArray(new HttpAdaptor[beanSet.size()]);
                        adaptor = (HttpAdaptor)(adaptors[0]);
                    }
                }
                else
                {
                    adaptor = new HttpAdaptor();
                    adaptor.setProcessor(processor);
                    adaptor.setPort(httpPort_);
                    server_.registerMBean(adaptor, adaptorName);
                    adaptor.start();
                }

            }

            ContainerMBean container;
            ObjectName containerName = new ObjectName(config_.getDomain()
                    + ".container:type=" + ContainerMBean.class.getName());
            if (server_.isRegistered(containerName))
            {
                Set beanSet = server_.queryMBeans(containerName, null);
                if (beanSet.size() > 0)
                {
                    ContainerMBean[] containers = (ContainerMBean[])beanSet.toArray(new ContainerMBean[beanSet.size()]);
                    container = (ContainerMBean)(containers[0]);
                }
            }
            else
            {
                container = new Container();
                server_.registerMBean(container, containerName);
            }

            StatisticsMBean statistics;
            ObjectName statisticsName = new ObjectName(config_.getDomain()
                    + ".statistics:type=" + StatisticsMBean.class.getName());
            if (server_.isRegistered(statisticsName))
            {
                Set beanSet = server_.queryMBeans(statisticsName, null);
                if (beanSet.size() > 0)
                {
                    StatisticsMBean[] statisticses = (StatisticsMBean[])beanSet.toArray(new StatisticsMBean[beanSet.size()]);
                    statistics = (StatisticsMBean)(statisticses[0]);
                }
            }
            else
            {
                statistics = new Statistics();
                server_.registerMBean(statistics, statisticsName);
            }
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }

    /**
     * Ăяo擾pinvoke\bhB
     * 
     * ۂ̃\bhĂяosOŁA
     * s񐔂sԂMBeanɋL^B
     * 
     * sɗOꍇ́A
     * O̔񐔂┭L^B
     * 
     * @param invocation
     *            C^[Zv^ɂĎ擾ꂽAĂяo\bh̏
     * @return invocationsƂ̖߂l
     * @throws Throwable invocationsƂɔO
     */
    public Object invoke(MethodInvocation invocation)
        throws Throwable
    {
        synchronized (this.getClass())
        {
            if (!isInitialized_)
            {
                isInitialized_ = true;
                init();
            }
        }

        // Ăяo擾B
        String className = getTargetClass(invocation).getName();
        String methodName = invocation.getMethod().getName();

        Object ret = null;
        try
        {
            S2JmxJavelinRecorder.preProcess(className, methodName, config_);

            //==================================================
            // \bhĂяoB
            ret = invocation.proceed();
            //==================================================

            S2JmxJavelinRecorder.postProcess(config_);
        }
        catch (Throwable cause)
        {
            S2JmxJavelinRecorder.postProcess(cause);

            //OX[AIB
            throw cause;
        }

        return ret;
    }

    /**
     * 
     * @param intervalMax
     */
    public void setIntervalMax(int intervalMax)
    {
        config_.setIntervalMax(intervalMax);
    }

    /**
     * 
     * @param throwableMax
     */
    public void setThrowableMax(int throwableMax)
    {
        config_.setThrowableMax(throwableMax);
    }

    /**
     * 
     * @param recordThreshold
     */
    public void setRecordThreshold(int recordThreshold)
    {
    	config_.setRecordThreshold(recordThreshold);
    }

    /**
     * 
     * @param domain
     */
    public void setDomain(String domain)
    {
        config_.setDomain(domain);
    }

    public void setJavelinFileDir(String javelinFileDir)
    {
    	config_.setJavelinFileDir(javelinFileDir);
    }
    
    /**
     * 
     * @param httpPort
     */
    public void setHttpPort(int httpPort)
    {
        httpPort_ = httpPort;
    }
}